(defstruct cl-clause
bindlist
lhs
rhs
doms
)

(defstruct cl-disjunct
bindlist
nodes
)

(defstruct theory  ;the type of coherent theories
  (nodes nil)
  (clauses nil)
  root
  (mass m_zero)
  (constraints nil)  ; constraints are partial functions 
  aux                ; from {AtomicPredicates} to {:Pos :Neg}
  )

(defstruct clause
  op
  lhs
  rhs
;freevars?
;bindlist?
)

(defstruct node
  formula
  pole
  (index (incf *pred-index-counter*))
)

(defstruct formula
  head
  args
  freevars
  (bindlist nil)
  (atom nil)
)
  
(defstruct atompred
  head
  arity
  nodes
)

(defstruct term
  head
  args
  freevars
  var
)
 
(defstruct parsedata
(preds nil)
(funs nil)
(vars nil)
)
